#include <stdlib.h>
#include <stdio.h>
#include "basic.h"


static int verbose = 0 ;


typedef struct {
  volatile int x,y;
  int r1,r2 ;
  volatile int start ;
} common_t ;

typedef struct {
  int id ;
  common_t *common ;
} ctx_t ;


void *T1(void *_p) {
  ctx_t *p = _p ;
  common_t *q = p->common ;
  while (!q->start) ;
  q->x = 1 ;
  q->r1 = q->y ;
  return NULL ;
}

void *T2(void *_p) {
  ctx_t *p = _p ;
  common_t *q = p->common ;
  while (!q->start) ;
  q->y = 1 ;
  q->r2 = q->x ;
  return NULL ;
}


void run(int size) {
  int count[2][2] ;
  count[0][0] = count[0][1] = count[1][0] = count[1][1] = 0 ;
  int k = 0 ;
  
  for ( ; ; ) {
    common_t c ;
    c.x = c.y = 0 ; c.start = 0 ;
    pthread_t th1,th2 ;
    ctx_t a1,a2 ;
    
    a1.id = 1 ; a1.common = &c ;
    create_thread(&th1,T1,&a1) ;
    a2.id = 2 ; a2.common = &c ;
    create_thread(&th2,T2,&a2) ;
    c.start = 1 ;    
    (void)join_thread(&th1) ; (void)join_thread(&th2) ;

    count[c.r1][c.r2]++ ;
    if (++k >= size) {
      k = 0 ;
      printf("**********\n") ;
      int nz = 0 ;
      for (int k1 = 0 ; k1 < 2 ; k1++)
        for (int k2 = 0 ; k2 < 2 ; k2++) {
          int c = count[k1][k2] ;
          if (c > 0) nz++ ;
          printf("%-5i> r1=%i r2=%i\n",c,k1,k2) ;
        }
      if (nz == 4) return ;
    }
  }
}


void usage(char *pgm) {
  fprintf(stderr,"Usage: %s [-v]* [n]\n",pgm) ;
}

int main(int argc, char **argv) {
  char * pgm = argv[0] ;
  int size = 100000 ;

  ++argv ;
  --argc ;
  while (argc > 0) {
    char *arg = *argv ;
    if (*arg == '-') {
      arg++ ;
      if (*arg == 'v') verbose++ ;
      else usage(pgm) ;
    } else {
      break ;
    }
    ++argv;
    --argc ;
  }
  if (argc == 1) {    
    size = atoi(argv[0]) ;
  }
  run(size) ;
  return 0 ;
}
