#include <stdlib.h>
#include <stdio.h>
#include "basic.h"
#include "fifo.h"

static int verbose = 0 ;
static int n = 2 ;


static pthread_barrier_t *barrier ;

typedef struct {
  int id ;
} ctx_t ;

void *runner(void *_p) {
  ctx_t *p = _p ;
  for (int k = 0 ; k < 4 ; k++) {
    wait_barrier(barrier) ;
    printf("<%i>",p->id) ; fflush(stdout) ;
    (void)wait_barrier(barrier) ;
    if (p->id == 0)  printf("\n") ;
  }
  return NULL ;
}

void run(void) {
  barrier = alloc_barrier(n) ;
  pthread_t th[n] ;
  ctx_t arg[n] ;
  for (int k = 0 ; k < n ; k++) {
    arg[k].id = k ;
    create_thread(&th[k],runner,&arg[k]) ;
  }

  for (int k = 0 ; k < n ; k++) {
    (void)join_thread(&th[k]) ;
  }
  free_barrier(barrier) ;
}


int main(int argc, char **argv) {
  --argc ; ++argv ;
  while (argc > 1) {
    char *arg = *argv ;
    if (*arg == '-') {
      arg++ ;
      if (*arg == 'v') verbose++ ;
      else exit(2) ;
    } else {
      break ;
    }
    --argc ; ++argv ;
  }
  if (argc > 0) n = atoi(argv[0]) ;
  run() ;
  return 0 ;
}
